# HTML parser for PDF --> MP3 converter
# Author Dorian Miller, UNC Chapel Hill
# Date April 26, 2003

# Notes: Expects a fixed format

'''
Parsing is very simple. Every element in the paper is between bold tags. Other tags are ignored. 

<b>Title </b>
<b> Author information </b>
<b> Abstract </b>
<b> Section heading </b>
Section Body
...
<b> Section heading </b>
Section Body

'''

from HTMLParser import HTMLParser
from paperPart import paperPart

            
class Mock_HTML(HTMLParser):

    def __init__(self):
        self.lparts = []
        self.currentPart = paperPart()
        #init of parent class (is this needed)
        self.reset()
    
    def handle_data(self, data):
        #print "**************data %s tag" % data
        self.currentPart.addBody(data)

    def handle_starttag(self, tag, attrs):
        #print ">>>>Encountered the beginning of a %s tag" % tag
        #self.currentPart.addTag(tag)
        if (tag == 'b'):
            self.lparts.append(self.currentPart)
            self.currentPart = paperPart()


    def handle_endtag(self, tag):
        #print "<<<<<Encountered the end of a %s tag" % tag
        x = "something"
        # Add final part to lparts
        if (tag == 'html'):
            print "</HTML>: Found end of paper"
            self.lparts.append(self.currentPart)
            self.currentPart = paperPart()
        