# Main program to convert PDF --> Mp3
# Author Dorian Miller, UNC Chapel Hill
# Date April 26, 2003

# Notes:
# PDF --> HTML has already been transformed.
# HTML is doctored for this example.


import string
import os
from msspeech import MSSpeech
from mock_html import Mock_HTML

def start():
    #file names
    #pdfname  = './paper/maria_ibm.pdf'
    #htmlname = './paper/mock_pdfmp3.html' # generated by pdftohtml
    #soundname  = './paper/pdf_mp3' # add number .wav or mp3

    htmlname = './paper/cut_gb_p33-kamels.html' # generated by pdftohtml
    soundname  = './paper/cut_gb_kamels' # add number .wav or mp3    

    num = 5;
    x = str(num)
    print x
    # Convert pdf to HTML
    # Already done
    # os.spawnl(os.P_WAIT, 'pdftohtml.exe','hello',pdfname)


    x = Mock_HTML()

    # Read and parse HTML file
    text = open(htmlname).read()
    #print str
    x.feed(text)
    #x.get_starttag_text()
    #x.close()

    paper = x.lparts

    print "length of paper ", len(paper)

    # This could be another class
    count =0
    spengine = MSSpeech()

    # Speak title
    count = 1
    text = " "+ paper[count].body 
    makeAudio(spengine, paper, count, "title", text)   
    print paper[count].body

    # Speak Paper info
    count = 2
    text = " "+ paper[count].body 
    makeAudio(spengine, paper, count, "Paper information", text)
    print paper[count].body

    # Abstract
    count = 3
    text = " "+ paper[count].body 
    makeAudio(spengine, paper, count, "Abstract", text)   
    print paper[count].body

    # Speak abstract

    # Speak section titles
    # speak sections

    length = len(paper)
    print "length ", length
    
    # Say the table of contents
    base =4
    fin = (length-base)//2
    offset = base
    print fin, " ", length
    for count in range(0, fin):
        ndx = base+2*count
        text = " " + paper[ndx].body
        #+ paper[ndx+1].body
        print "Speak this file ", ndx
        makeAudio(spengine, paper, offset+count, " ", text)

    offset = fin+3
    for count in range(0, fin):
        ndx = base+2*count
        text = " " + paper[ndx].body + paper[ndx+1].body
        print "Speak this file ", ndx
        makeAudio(spengine, paper, offset+count, "Section", text)
                

    #if (count >2):
    #    break
    # convert to MP3
    #os.spawnl(os.P_WAIT, 'lamewavmp3.exe','hello',fname)
    print count, " "

    print "finished"

def makeAudio(spengine, paper, count, annotation, phrase):
    #print paper[0], " ", count, " ", annotation, " ", phrase

    soundname  = './paper/cut_gb_kamels' # add number .wav or mp3

    # ensure 2-digit number
    if (count < 10):
        fname = soundname + '0' + str(count) + '.wav'
    else:
        fname = soundname + str(count) + '.wav'
    
    spengine.startFile(fname)
    spengine.sayMore(annotation, phrase)
    spengine.endFile()

    # Convert to mp3
    os.spawnl(os.P_WAIT, 'lamewavmp3.exe','hello',fname)

if __name__=='__main__':
    print "Start the PDF to Mp3 converter"
    start()