# PDF --> Mp3 conversion project
# Author Dorian Miller, UNC Chapel Hill
# Date April 26, 2003

from win32com.client import constants
import win32com.client
import pythoncom

"""Run DOS executables
os.spawnl(os.P_WAIT, 'd:\\pdftohtml\\xpdf2\\pdftohtml.exe','hello','d:\\trash2.pdf')"""

"""Sample code for using the Microsoft Speech SDK 5.1 via COM in Python.
    Requires that the SDK be installed (it's a free download from
            http://www.microsoft.com/speech
    and that MakePy has been used on it (in PythonWin,
    select Tools | COM MakePy Utility | Microsoft Speech Object Library 5.1).

    After running this, then saying "One", "Two", "Three" or "Four" should
    display "You said One" etc on the console. The recognition can be a bit
    shaky at first until you've trained it (via the Speech entry in the Windows
    Control Panel."""
class MSSpeech:
    """ Initialize the speech recognition with the passed in list of words """
    def __init__(self):
		# For text-to-speech
        self.speaker = win32com.client.Dispatch("SAPI.SpVoice")
        # For text-to-speech output to file
        self.wavFormat = win32com.client.Dispatch("SAPI.SpAudioFormat")        
        self.wavFormatEx = win32com.client.Dispatch("SAPI.SpWaveFormatEx")

        #SAFT44kHz16BitStereo = 35
        self.wavFormat.Type = 35
        print "wavFormat.Type " , self.wavFormat.Type
        """
        self.wavFormatEx.SamplesPerSec = 44100
        self.wavFormatEx.BitsPerSample = 16
        self.wavFormatEx.Channels = 2
        self.wavFormatEx.BlockAlign = 2
        self.wavFormatEx.AvgBytesPerSec  = 2*44100
        self.wavFormat.SetWaveFormatEx(self.wavFormatEx)
        """
        # For text-to-speech output to file
        self.wavFile = win32com.client.Dispatch("SAPI.SpFileStream")

        self.voiceNames = self.speaker.GetVoices()        
        print "Get to get the MSSpeech voice names"
        for n in self.voiceNames:
            print "Voice names -- ", n.GetDescription()
        print "============================"

        # Change the voice
        self.speaker.Voice = self.voiceNames[0]

        
        # Announce we've started
        self.speaker.Rate=1
        self.say("Started successfully")
        #self.say("Dorian is happy this works")

        # keep for restoring later
        self.blank = self.speaker.AudioOutputStream

        
        
    """Speak a word or phrase"""
    def say(self, phrase):
        self.speaker.Speak(phrase)

    # Annotate a phrase. The annotation is emphasized with a different voice. 
    def sayMore(self, annotation, phrase):
        self.speaker.Voice = self.voiceNames[2]
        self.speaker.Speak(annotation)

        self.speaker.Voice = self.voiceNames[0]
        self.speaker.Speak(phrase)        


    def startFile(self, filename):
        #self.wavFile=self.wavFormat;
        # SSFMCreateForWrite = 3
        self.wavFile.Format = self.wavFormat
        self.wavFile.Open(filename, 3, 0)
        self.speaker.AudioOutputStream = self.wavFile
        

    def endFile(self):
        self.wavFile.Close()
        # keep for restoring later
        self.speaker.AudioOutputStream = self.blank

    


"""The callback class that handles the events raised by the speech object.
    See "Automation | SpSharedRecoContext (Events)" in the MS Speech SDK
    online help for documentation of the other events supported. """
class ContextEvents(win32com.client.getevents("SAPI.SpSharedRecoContext")):
    """Called when a word/phrase is successfully recognized  -
        ie it is found in a currently open grammar with a sufficiently high
	confidence"""
    def OnRecognition(self, StreamNumber, StreamPosition, RecognitionType, Result):
        newResult = win32com.client.Dispatch(Result)
        print "You said: ",newResult.PhraseInfo.GetText()
    
#if __name__=='__main__':
#    wordsToAdd = [ "One", "Two", "Three", "Four" ]
#    speechReco = SpeechRecognition(wordsToAdd)
    
